"""
示例PU单元,仅提供一个数据调用接口和对应的数据订阅接口,返回随机字符串,用于演示框架使用
"""
from dalpyframe.unitbase import ProcessUnit

class LogExample(ProcessUnit):
    """
    常驻任务单元,需描述最小资源要求

    Attributes:
        CPU: 100
        Memory: 64
        Version: 1.0.1
    """
    def custom_init(self)->bool:
        """
        业务单元自定义初始化
        """
        return True

    def printlog_data(self,_caller,_index):
        """
        获取模拟客户信息

        Attributes:
            ACCode: 111
        Returns:
            {}
        Examples:
            {}
        """
        self.logger.debug("This is a debug log!")
        self.logger.info("This is a info log!")
        self.logger.warning("This is a warning log!")
        self.logger.error("This is a error log!")
        try:
            _k = 32/0
        except ZeroDivisionError:
            self.logger.exception("This is a exception log in except!")
        finally:
            self.logger.error("This is a exception log in finally!")
        return (0,'success',{})

    def test(self):
        """
        单元测试
        """
        self.printlog_data({},{})
        return True

