"""
示例PU单元,仅提供一个简单接口,用于演示框架使用
"""
from dalpyframe.unitbase import ProcessUnit

# pylint: disable=too-few-public-methods
class RedisExample(ProcessUnit):
    """
    常驻任务单元,需描述最小资源要求

    Attributes:
        CPU: 100
        Memory: 64
        Version: 1.0.1
    """
    def custom_init(self)->bool:
        """
        业务单元自定义初始化
        """
        return True

    def write_data(self,_caller,index):
        """
        数据写入redis

        Attributes:
            ACCode: 111
        Returns:
            {}
        Examples:
            {}
        """
        self.redis_conn.set(index['key'],index['value'])
        return (0,'success',{})

    def read_data(self,_caller,index):
        """
        从redis中读数据

        Attributes:
            ACCode: 111
        Returns:
            {}
        Examples:
            {}
        """
        value = self.redis_conn.get(index['key'])
        return (0,'success',value.decode('utf-8'))

    def test(self):
        """
        单元测试
        """
        return True
