"""
示例PU单元,演示框架文件存储使用,如果在本地调试OSS存储,需要通过环境变量设置OSS接入信息,详情咨询alex.c@daline.com.cn
"""
import os
from dalpyframe.unitbase import ProcessUnit

class StoreExample(ProcessUnit):
    """
    常驻任务单元,需描述最小资源要求

    Attributes:
        CPU: 100
        Memory: 64
        Version: 1.0.1
    """
    def custom_init(self)->bool:
        """
        业务单元自定义初始化
        """
        return True

    def randwrite_data(self,_caller,_index):
        """
        获取模拟客户信息

        Attributes:
            ACCode: 111
        Returns:
            {}
        Examples:
            {}
        """
        with open(self.folder_temp+'try_write.txt','w',encoding='utf8') as file:
            file.write('hello temp folder')
        with open(self.folder_nfs+'try_write.txt','w',encoding='utf8') as file:
            file.write('hello nfs folder')
        with open(self.folder_http+'try_write.txt','w',encoding='utf8') as file:
            file.write('hello http folder')
        self.logger.info("visit http file from %s",
            self.http_link(self.folder_http+'try_write.txt'))
        self.logger.info("visit http file from %s in web project in the same space",
            self.httpstore_link(self.folder_http+'try_write.txt'))
        # self.oss_upload_file('try_write.txt',self.folder_temp+'try_write.txt')
        # self.oss_set_acl('try_write.txt',2)
        # self.logger.info("visit oss file from %s",
        #     self.oss_get_file_info('try_write.txt').resp.response.url)
        return (0,'success',{})

    def listfiles_data(self,_caller,_index):
        """
        获取模拟客户信息

        Attributes:
            ACCode: 111
        Returns:
            {}
        Examples:
            {}
        """
        folder_files = {}
        folder_files['temp'] = os.listdir(self.folder_temp)
        folder_files['nfs'] = os.listdir(self.folder_nfs)
        folder_files['nfs_author'] = os.listdir(self.folder_nfs_author)
        folder_files['http'] = os.listdir(self.folder_http)
        # folder_files['oss'] = self.oss_list_files()
        return (0,'success',folder_files)

    def readfile_data(self,_caller,index):
        """
        获取模拟客户信息

        Attributes:
            ACCode: 111
        Returns:
            {}
        Examples:
            {}
        """
        ret = ''
        if index['type'] == 'temp':
            with open(self.folder_temp+index['file'],'r',encoding='utf8') as file:
                ret = file.read()
        if index['type'] == 'nfs':
            with open(self.folder_nfs+index['file'],'r',encoding='utf8') as file:
                ret = file.read()
        if index['type'] == 'http':
            ret = self.http_link(self.folder_http+index['file'])
        # if index['type'] == 'oss':
        #     ret = self.oss_get_file_info(index['file']).resp.response.url
        return (0,'success',ret)

    def test(self):
        """
        单元测试
        """
        self.listfiles_data({},{})
        return True
